<?php

namespace ManiaLivePlugins\eXpansion\Menu\Gui\Widgets;

use ManiaLib\Gui\Elements\Frame;
use ManiaLib\Gui\Elements\Quad;
use ManiaLib\Gui\Layouts\Column;
use ManiaLivePlugins\eXpansion\Gui\Elements\Button;

class MenuWidget extends \ManiaLivePlugins\eXpansion\Gui\Widgets\PlainWidget
{
    public $items = [];
    protected $frame;
    protected $script;

    protected $button;

    protected function onConstruct()
    {
        parent::onConstruct();


        $this->button = new Button(28,6);
        $this->button->setText('Menu');
        $this->button->colorize("3af");
        $this->button->setPosition(-159, 78);
        $this->button->setId('MenuButton');
        $this->button->setScriptEvents();
      //  $this->addComponent($this->button);

        $this->frame = new \ManiaLive\Gui\Controls\Frame(0, 0, new Column(50, 20));
        $this->frame->setId("Menu");
        $this->addComponent($this->frame);

        $this->script = new \ManiaLivePlugins\eXpansion\Gui\Structures\Script("Menu\Gui\Script");

        $version = \ManiaLivePlugins\eXpansion\Core\Core::EXP_VERSION;
        $this->script->setParam("version", $version);
        $this->script->setParam("name", "Submenu");
        $storage = \ManiaLive\Data\Storage::getInstance();
        if ($storage->gameInfos->gameMode == \Maniaplanet\DedicatedServer\Structures\GameInfos::GAMEMODE_SCRIPT) {
            $this->script->setParam(
                "gameMode",
                \ManiaLivePlugins\eXpansion\Gui\Gui::fixString($this->storage->gameInfos->scriptName)
            );
        } else {
            $this->script->setParam("gameMode", $storage->gameInfos->gameMode);
        }
        $this->script->setParam("forceReset", $this->getBoolean(DEBUG));
        $this->registerScript($this->script);

        $inputbox = new \ManiaLivePlugins\eXpansion\Gui\Elements\Inputbox("widgetStatus");
        $inputbox->setPosition(900, 900);
        $inputbox->setScriptEvents();
        $this->addComponent($inputbox);

    }

    public function addGroup($name)
    {
        $this->items[] = 1;
        $group = new \ManiaLivePlugins\eXpansion\Menu\Gui\Controls\GroupItem($name, count($this->items));
        $this->frame->addComponent($group);
        return $group;
    }

    public function onShow()
    {
        $this->script->setParam("itemCount", count($this->items));
        parent::onShow(); // TODO: Change the autogenerated stub
    }

    public function addItem($itemName, $handle, $plugin)
    {
        $action = $this->createAction(array($plugin, "actionHandler"), $handle);
        $this->items[] = 1;
        /* @var $config \ManiaLivePlugins\eXpansion\Gui\Config */
        $config = \ManiaLivePlugins\eXpansion\Gui\Config::getInstance();

        $frame = new \ManiaLive\Gui\Controls\Frame();
        $frame->setSize(30, 5);

        /* @var $label \ManiaLivePlugins\eXpansion\Gui\Elements\DicoLabel */
        $label = new \ManiaLivePlugins\eXpansion\Gui\Elements\DicoLabel(30, 5);
        $label->setText(eXpGetMessage($itemName));
        $label->setId("item_" . count($this->items));
        $label->setAttribute("class", "menu item");
        $label->setPosX(2);
        $label->setTextSize(1);
        $label->setStyle("TextRaceChat");
        $label->setTextColor("fff");
        $label->setAttribute("data-action", $action);
        $label->setAlign("left", "center");

        $quad = new Quad(30, 5);
        $quad->setBgcolor($config->style_widget_bgColorize);
        $quad->setBgcolorFocus($config->style_widget_title_bgColorize);
        $quad->setId("mQuad_" . count($this->items));
        $quad->setAlign("left", "center");
        $quad->setScriptEvents();
        $quad->setAttribute("data-action", $action);

        $frame->addComponent($quad);
        $frame->addComponent($label);

        $this->frame->addComponent($frame);
    }
}
